#!/usr/bin/perl

use DBI;
use DBD::Pg;
use Time::Local;
use Time::localtime;

	&ParseLanguage;

	$Copyright = q(<hr width="250"><small><a href="http://iserverd.khstu.ru/isdwm/">IServerd Web Manager</a> v1.3 beta 1<br>Copyright &copy; 2001-2002 by <a href="mailto:isdwm@nwnet.ru">A.V. Linetskiy</a><br></small>);

# ================ DEFAULTS
	$config_version = 3;
	$db_name = "users_db";
	$db_user = "iserverd";
	$db_pass = "password";
	$sendmailprog = "sendmail";
	$MaxPageItems = 25;
	$AdminMail = "";
	$MainTableSize = 950;
	$LeftTableSize = 180;
	$InputBGColor=q|#DDDDDD|;
	$InputMouseOver=q|#F6FBFF|;
	$TableBorderColor=q|#FFFFFF|;
	$TableColor=q|EFEFEF|;
	$MainTableColor=q|#DEE3E7|;
	$RightTablesCellPadding=q|2|;
	$MainTableCellPadding=q|2|;
	$TableColorStrip=q|#C8D1D7|;
	$BGColor=q|#DEE3E7|;
	$MenuSelectedColor=q|#D1D1D1|;
	$MenuOverColor=q|#FFFFFF|;
	$WebCodepage=q|windows-1251|;
	$MenuCellPadding=q|3|;
	$win2koi=q|yes|;
	$koi2win=q|yes|;
	$sendmailprog=q|sendmail|;
	$BodyTDStyle=q|    font-family : Arial, Verdana, sans-serif;
    font-size : 11pt;
|;
	$ALink=q|    color : #000099;
    text-decoration: none|;
	$AHover=q|    text-decoration: underline;|;
	$ISD_control = "/etc/iserverd/iserverd.sh";
	$mail_reg = "yes";
	$default_pass = "isdrulez";
	$MaxAddUIN = 2000; 
	$MinAddUIN = 1000;
	$URLToImages = "/img";
# ================ END DEFAULTS
	%MenuItems = (
		10  =>  (["$Language{phrase153}", ""]),
		20  =>  (["$Language{phrase154}", "adduser"]),
		30  =>  (["$Language{phrase62}", "list"]),
#		35  =>  ([" ", "sysmess"]),
		40  =>  (["$Language{phrase155}", "deluser"]),
		50  =>  (["$Language{phrase156}", "lockuser"]),
		60  =>  (["$Language{phrase157}", "newlock"]),
		70  =>  (["$Language{phrase158}", "regreq"]),
		80  =>  (["$Language{phrase159}", "online"]),
		90  =>  (["$Language{phrase160}", "offmess"]),
		100 =>  (["$Language{phrase161}", "setup"]),
		110 =>  (["$Language{phrase162}", "exit"])
	);
	%OnlineStatus = (
		0  =>  (["online.gif", "Online"]),
		1  =>  (["away.gif", "Away"]),
		2  =>  (["dnd.gif", "DND"]),
		4  =>  (["na.gif", "N/A"]),
		5  =>  (["na.gif", "N/A"]),
		16 =>  (["occupied.gif", "Occupied"]),
		17 =>  (["dnd.gif", "DND"]),
		32 =>  (["ffc.gif", "Free For Chat"]),
		256=>  (["invisible.gif", "Invisible"]),
		257=>  (["status.gif", "Unknown"]),
		258=>  (["offline.gif", "Offline"])
	);
	%DesktopStatus = ( #   ?  -...
		 -1 =>  (["systray.gif", "$Language{phrase163}"]),
		 0  =>  (["unknown.gif", "$Language{phrase164}"]),
		 1  =>  (["desktop.gif", "$Language{phrase165}"])
	);
	print "Content-type: text/html; charset=windows-1251\n";

	if ($ENV{'REQUEST_METHOD'} eq 'GET')
	{
		$query_string=$ENV{'QUERY_STRING'};
	} 
	elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
	{
		sysread(STDIN,$query_string,$ENV{'CONTENT_LENGTH'});
	};
	@formfields=split(/&/,$query_string);
		foreach (@formfields) 
		{
			my ($key, $value) = split(/=/,$_);
			$value=~s/\+/ /g;
			$value=~s/%([0-9A-H]{2})/pack('C',hex($1))/ge;
			&win2koi($value);
			$in{$key}=$value;
		}

	foreach (split(/; /, $ENV{'HTTP_COOKIE'})) 
	{
		($par, $val) = split(/=/,$_);
	        $val =~ s/%([0-9A-H]{2})/pack('C',hex($1))/ge;
		$cook{$par} = $val;
	}

	if ($in{action} eq "savesettings")
	{
#		($in{MailRegSubject},$in{MailTextSubject}) = &koi2win($in{MailRegSubject},$in{MailTextSubject});
		foreach (keys %in)
		{
#			$in{$_} =~ s/[^\\]([$|@|\|])/\\$1/g;
			$in{$_}=~s/\|/\\|/g if $in{$_} =~/[^\\]\|/g;
		}
		open (CONFIG, ">isdwm.conf") or die "$!";
		print CONFIG <<CONF__;
# IServerd Web Manager configuration file

\$config_version=$config_version;
\$db_name=q|$in{db_name}|;
\$db_user=q|$in{db_user}|;
\$db_pass=q|$in{db_pass}|;
\$Admins=q|$in{Admins}|;
\$MaxPageItems=q|$in{MaxPageItems}|;
\$AdminMail=q|$in{AdminMail}|;
\$MainTableSize=q|$in{MainTableSize}|;
\$LeftTableSize=q|$in{LeftTableSize}|;
\$InputBGColor=q|$in{InputBGColor}|;
\$InputMouseOver=q|$in{InputMouseOver}|;
\$TableBorderColor=q|$in{TableBorderColor}|;
\$TableColor=q|$in{TableColor}|;
\$RightTablesCellPadding=q|$in{RightTablesCellPadding}|;
\$MainTableColor=q|$in{MainTableColor}|;
\$MainTableCellPadding=q|$in{MainTableCellPadding}|;
\$TableColorStrip=q|$in{TableColorStrip}|;
\$BGColor=q|$in{BGColor}|;
\$MenuSelectedColor=q|$in{MenuSelectedColor}|;
\$MenuOverColor=q|$in{MenuOverColor}|;
\$WebCodepage=q|$in{WebCodepage}|;
\$MenuCellPadding=q|$in{MenuCellPadding}|;
\$win2koi=q|$in{win2koi}|;
\$koi2win=q|$in{koi2win}|;
\$sendmailprog=q|$in{sendmailprog}|;
\$BodyTDStyle=q|$in{BodyTDStyle}|;
\$ALink=q|$in{ALink}|;
\$AHover=q|$in{AHover}|;
\$ISD_control=q|$in{ISD_control}|;
\$mail_reg=q|$in{mail_reg}|;
\$default_pass=q|$in{default_pass}|;
\$default_nick=q|$in{default_nick}|;
\$default_frst=q|$in{default_frst}|;
\$default_last=q|$in{default_last}|;
\$default_lock_text=q|$in{default_lock_text}|;
\$MaxAddUIN=$in{MaxAddUIN}; 
\$MinAddUIN=$in{MinAddUIN};
\$FirstFreeUIN=q|$in{FirstFreeUIN}|;
\$URLToImages=q|$in{URLToImages}|;
\$TextColor=q|$in{TextColor}|;
\$MailRegSubject=q|$in{MailRegSubject}|;
\$MailTextSubject=q|$in{MailTextSubject}|;
CONF__
		close(CONFIG);
		chmod (0600, "isdwm.conf");
	}
	$CurrentConfig = $config_version;
	eval  {do "isdwm.conf"} || &Setup(1);
	if ($CurrentConfig != $config_version) { &Setup(3) };
	if (!$Admins) { &Setup(2) };

	$InputParam = qq(Onmouseover="this.style.backgroundColor='$InputMouseOver'"; onmouseout="this.style.backgroundColor='$InputBGColor'";);

	$dbh = DBI->connect("dbi:Pg:dbname=$db_name;host=localhost;port=5432", "$db_user", "$db_pass") || &Setup(4);

	# Checking cookies.
	if (!(&CheckAccess ($in{'adminuin'}, $in{'adminpass'})) && !(&CheckAccess ($cook{'adminuin'}, $cook{'adminpass'})))
	{
		&PrintEntryExit("$Language{phrase4}");
		print <<HTML__;
	<table border=0 bgcolor=$TableBorderColor cellpadding=3 cellspacing=1 width=220>
	<FORM ACTION="isdwm.cgi" METHOD="POST" name="login">
	  <tr bgcolor=$TableColorStrip><td colspan=2 align=center>$Language{phrase3}</td></tr>
	  <tr bgcolor=$TableColor><td>UIN:</td><td><INPUT TYPE="text" NAME="adminuin" SIZE="8" $InputParam></td></tr>
	  <tr bgcolor=$TableColor><td>$Language{phrase1}</td><td><INPUT TYPE="password" SIZE="8" NAME="adminpass" $InputParam></td></tr>
          <tr bgcolor=$TableColor><td><INPUT TYPE="SUBMIT" VALUE=" $Language{phrase2} " $InputParam></td><td><INPUT TYPE="CHECKBOX" NAME="remember" $InputParam> $Language{phrase7}</td></tr>
	</FORM>
	</table>
	<br>
	$Copyright<br>$Copyright_local
	<SCRIPT LANGUAGE="JavaScript">
	<!-- HIDE
	document.login.adminuin.focus();
HTML__
	if ($in{adminuin} || $in{adminpass})
	{
        print <<HTML__;
alert('$Language{phrase170}');
HTML__
	}
    print <<HTML__;
	// STOP HIDING FROM OTHER BROWSERS -->
	</SCRIPT>
	</td><tr></table>
	</body>
	</HTML>
HTML__
exit;
	}
	else
	{
	        if ($in{adminuin} && $in{adminpass})
		{

     			&SetCookies("adminuin","$in{adminuin}");
			&SetCookies("adminpass","$in{adminpass}");
	     		print "\n";
		}
	}

if ($in{action} eq "offmess") 
{
	&PrintHeader ("$Language{phrase11}");
	&PrintMenu (90);
        if (exists $in{datefrom}) 
	{
		($datefrom=$in{datefrom}) =~ s/(\d+).(\d+).(\d+)/timelocal(0,0,0,$1,$2-1,$3-\1900)/ge;
		unless (defined $datefrom) 
		{
			print "UIN $in{uin}: $Language{phrase5}: <b>$in{datefrom}</b>. $Language{phrase6}.";
			&PrintFooter;
			exit;
		}
		($dateto=$in{dateto}) =~ s/(\d+).(\d+).(\d+)/timelocal(59,59,23,$1,$2-1,$3-1900)/ge;
		unless (defined $dateto) 
		{
			print "UIN $in{uin}: $Language{phrase5}: <b>$in{dateto}</b>. $Language{phrase6}.";
			&PrintFooter;
			exit;
		}
		$addon="WHERE (msg_date>$datefrom AND msg_date<$dateto)";
	        if (exists $in{del}) 
		{
			$rv=$dbh->do("DELETE FROM users_messages $addon");
			print "$Language{phrase8} $Language{phrase9} $in{datefrom} $Language{phrase10} $in{dateto}.";
			&PrintFooter;
			exit;
		}
		$urlsearch = "&show=&datefrom=$in{datefrom}&dateto=$in{dateto}";
	}
	elsif ($in{do} eq "search")
	{
		$addon="WHERE msgtext ILIKE '\%$in{search}\%'";
		&koi2win($in{search});
		$urlsearch = "&do=search&search=$in{search}";
	}	
	if ($in{sort} eq "to_uin") { $sort="ORDER BY to_uin" }
		elsif ($in{sort} eq "from_uin") { $sort="ORDER BY from_uin" }
			elsif ($in{sort} eq "msg_type") { $sort="ORDER BY msg_type" }
				else { $sort="ORDER BY msg_date" };
	if (!$in{page}) {$in{page}=0;} else {$in{page}--};

	$PageS = $in{page}+1;
	{
		$LIMIT = qq(LIMIT $MaxPageItems, ).$MaxPageItems*$in{page};
	}
	$sth=$dbh->prepare("SELECT COUNT(to_uin) from users_messages $addon");
	$sth->execute;
	$TotalByQuery = $sth->fetchrow;
	$sth=$dbh->prepare("SELECT * FROM users_messages $addon $sort DESC $LIMIT ");
	$sth->execute;
	for ($i = 1; $i<($TotalByQuery/$MaxPageItems)+1; $i++) 
	{
		if ($PageS != $i) 
		{
			$page .= qq(<a href="isdwm.cgi?action=offmess&sort=$in{sort}&page=$i$urlsearch"><b>$i</b></a> );
		}
			else
		{
			$page .= "<b>$i </b>";
		}
	}

	print qq|
	<FORM ACTION="isdwm.cgi" METHOD="GET">
	<INPUT TYPE="hidden" NAME="action" VALUE="offmess">
	<table border=0 bgcolor="$TableBorderColor" cellpadding="$RightTablesCellPadding" cellspacing="1" width="100%">
	<tr bgcolor=$TableColorStrip><td colspan=5 align=center><b>$Language{phrase11}</b></td></tr>
	<tr bgcolor=$TableColorStrip><td colspan=5>$Language{phrase12}: $Language{phrase9} <INPUT TYPE="text" NAME="datefrom" SIZE="10" VALUE="$in{datefrom}" $InputParam> $Language{phrase10} <INPUT TYPE="text" NAME="dateto" VALUE="$in{dateto}" SIZE="10" $InputParam> <INPUT TYPE="SUBMIT" NAME="show" VALUE="$Language{phrase14}" $InputParam> <INPUT TYPE="SUBMIT" NAME="del" VALUE="$Language{phrase15}" $InputParam> <small>($Language{phrase16})</small></td></tr></form>
	<FORM ACTION="isdwm.cgi" METHOD="GET">
	<INPUT TYPE="hidden" NAME="action" VALUE="offmess">
	<INPUT TYPE="hidden" NAME="do" VALUE="search">
	<tr bgcolor=$TableColorStrip><td colspan=5>$Language{phrase13}: <INPUT TYPE="text" NAME="search" SIZE="10" VALUE="$in{search}" $InputParam> <INPUT TYPE="SUBMIT" VALUE="$Language{phrase18}" $InputParam></td></tr>
	</FORM>
	<tr bgcolor=$TableColorStrip align="center"><td><a href="isdwm.cgi?action=offmess&page=1$urlsearch"><b>$Language{phrase17}</b></td><td width=1><a href="isdwm.cgi?action=offmess&sort=from_uin&page=1$urlsearch"><nobr><b>$Language{phrase216}</b></nobr></a></td><td width=1><a href="isdwm.cgi?action=offmess&sort=to_uin&page=1$urlsearch"><nobr><b>$Language{phrase22} (UIN)</b></nobr></a></td><td width=1><a href="isdwm.cgi?action=offmess&sort=msg_type&page=1$urlsearch"><b>$Language{phrase42}</b></a></td><td><b>$Language{phrase21}</b></td></tr>|;
	if ($sth->rows != 0)
	{
		while (@rows=$sth->fetchrow)
		{
			&koi2win(@rows);
			print qq|<tr bgcolor=$TableColor align="center"><td heigth="1"><nobr>|.sprintf ("%02d:%02d <b>%02d.%02d.%d</b>",($t = localtime($rows[2]))->hour, $t->min, $t->mday, $t->mon+1, $t->year+1900).qq|</nobr></td><td align="center"><a href="isdwm.cgi?action=edituin&uin=$rows[1]">$rows[1]</a></td><td><a href="isdwm.cgi?action=edituin&uin=$rows[0]">$rows[0]</a></td><td>|;
			if ($rows[3]==1)
			{
				print qq(<img src="$URLToImages/message.gif" border=0 width="16" height="16" alt="Message">);
				$msg="$rows[4]";
			}
			elsif ($rows[3]==4)
			{
				print qq(<img src="$URLToImages/url.gif" border=0 width="16" height="16" alt="URL">);
				$msg = sprintf("$Language{phrase24}: %s<br>URL: <a href=\"%s\">%s </a>", (@_=split(//,$rows[4])), $_[1]);
			}
			elsif ($rows[3]==6)
			{
				print qq(<img src="$URLToImages/auth.gif" border=0 width="16" height="16" alt="Authorise">);
				$msg = sprintf("%s %s %s %s", (@_=split(//,$rows[4])));
			}
			elsif ($rows[3]==12)
			{
				print qq(<img src="$URLToImages/regreq.gif" border=0 width="16" height="16" alt="Registration request">);
				$msg = sprintf("%s %s %s %s", (@_=split(//,$rows[4])));
			}
			elsif ($rows[3]==20)
			{
				print qq(<img src="$URLToImages/system.gif" border=0 width="16" height="16" alt="System message">);
				$msg = sprintf("%s %s %s %s %s %s", (@_=split(//,$rows[4])));
			}
			elsif ($rows[3]==13)
			{
				print qq(<img src="$URLToImages/web.gif" border=0 width="16" height="16" alt="Web message">);
				$msg = $rows[4];
			}
			else 
			{
				print qq(<img src="$URLToImages/status.gif" border=0 width="16" height="16" alt="$Language{phrase44} [$rows[3]]">);
				$msg = $rows[4];
			}	
			print qq|</td><td align="left">$msg</td></tr>|;
		}
	}
	print qq|<tr><td colspan=5>$Language{phrase20}: $page</td></tr></table>|;
	&PrintFooter; exit;
}	
if ($in{action} eq "online")
{
	&PrintHeader ("$Language{phrase220}");
	&PrintMenu (80);

	$sth=$dbh->prepare("SELECT online_users.uin,online_users.iadr,online_users.stat,online_users.uptm,online_users.prv,online_users.state,users_info_ext.nick from online_users,users_info_ext where online_users.uin=users_info_ext.uin ORDER BY uin");

	$sth->execute;
	$count=$sth->rows;


	print qq|
	<table border=0 bgcolor="$TableBorderColor" cellpadding="$RightTablesCellPadding" cellspacing="1" width="100%">
	<tr bgcolor=$TableColorStrip><td colspan=7 align=center><b>$Language{phrase20} ($count)</b></td></tr>
	<tr bgcolor=$TableColor align=center><td><b>UIN</b></td><td><b>NICK</b></td><td><b>IP</b></td><td><b>V</b></td><td><b>$Language{phrase76}</b></td><td><b>$Language{phrase45}</b></td><td><b><img src="$URLToImages/status.gif" border=0 width="16" height="16" alt="$Language{phrase43}"></b></td></tr>|;
	while (@rows=$sth->fetchrow)
	{
		$rows[3] = int((time-$rows[3])/60);
		&koi2win($rows[6]);
		&GetIP($rows[1]);

		print qq|<tr bgcolor=$TableColor align=center><td><a href="isdwm.cgi?action=edituin&uin=$rows[0]">$rows[0]</a></td><td>$rows[6]</td><td align=left>$rows[1]</td><td>$rows[4]</td><td>$rows[3]</td><td>|;
		if ($rows[4] == 3) {  print qq|<img src="$URLToImages/$DesktopStatus{$rows[5]}->[0]" border=0 width="16" height="16" alt="$DesktopStatus{$rows[5]}->[1] [$rows[5]]">| }
		else { print "-" }; print "</td><td>";
		&PrintOnlineStatus($rows[2]); 
		print qq|</td></tr>|;
	}
	print "</table>";
	&PrintFooter; exit;
}
if ($in{action} eq "edituin") 
{

	if ($in{do} eq "submit")
	{
		$in{llog} =~ s/(\d{2}):(\d{2}) (\d{2}).(\d{2}).(\d{4})/$llog_time = timelocal(0,$2,$1,$3,$4-1,$5-1900)/ge;
		unless (defined $llog_time) 
		{
			&PrintHeader ("$Language{phrase26} #$in{uin}");
			&PrintMenu (30);
			print "UIN $in{uin}:$Language{phrase28}. $Language{phrase29}: <b>$in{llog}</b>. $Language{phrase30}.";
			&PrintFooter;
			exit;
		}
		$in{cdate} =~ s/(\d{2}):(\d{2}) (\d{2}).(\d{2}).(\d{4})/$cr_time = timelocal(0,$2,$1,$3,$4-1,$5-1900)/ge;

		if ($in{'auth'} ne "0") { $in{'auth'} = 1 };
		$rv=$dbh->do("UPDATE users_info_ext SET pass='$in{pass}', llog='$llog_time', bcst='$in{bcst}', cdate='$cr_time', cpass='$in{cpass}', nick='$in{nick}', frst='$in{frst}', last='$in{last}', email1='$in{email1}', email2='$in{email2}', email3='$in{email3}', e1publ='$in{e1publ}', auth='$in{auth}', sex='$in{sex}', age='$in{age}', notes='$in{notes}' where uin=$in{uin}");
		if ($rv != 1)
		{
			&PrintHeader ("$Language{phrase26} #$in{uin}");
			&PrintMenu (30);
			print "UIN $in{uin}:$Language{phrase28}. $Language{phrase30}.";
			&PrintFooter;
			exit;
		}
		&PrintHeader ("$Language{phrase32}: $in{uin}");
		&PrintMenu (30);
		print qq(<b>UIN $in{uin}: $Language{phrase32}.</b> <BR> <a href="isdwm.cgi?action=edituin&uin=$in{uin}">$Language{phrase33}.);
		&PrintFooter;
		exit;
	}
	$sth=$dbh->prepare("SELECT * from users_info_ext WHERE uin=$in{uin}");	
	$sth->execute;
	$Result = $sth->rows;
	if ($Result != 1) {
		&PrintHeader ("$Language{phrase34}!");
		&PrintMenu (30);
		printf ("<h2>$Language{phrase34}: $Language{phrase35}!</h2>", $in{uin});
		&PrintFooter; exit;
	}
	@rows=$sth -> fetchrow;
	&PrintHeader ("$Language{phrase36} #$in{uin}");
	&PrintMenu (30);
	&koi2win(@rows);
	&GetIP($rows[4]);
	print qq|
	<FORM ACTION="isdwm.cgi" METHOD="POST">
	<INPUT TYPE="hidden" NAME="action" VALUE="edituin">
	<INPUT TYPE="hidden" NAME="do" VALUE="submit">
	<INPUT TYPE="hidden" NAME="uin" VALUE="$rows[0]">
	<table border=0 bgcolor="$TableBorderColor" cellpadding="$RightTablesCellPadding" cellspacing="1" width="100%">
		<tr><td bgcolor="$TableColorStrip" colspan="2" align="center"><b>$Language{phrase36} #$rows[0]</b></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase1}:</td><td><INPUT TYPE="text" NAME="pass" VALUE="$rows[1]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase25}:</td><td><INPUT TYPE="text" NAME="nick" VALUE="$rows[8]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase49}:</td><td><INPUT TYPE="text" NAME="frst" VALUE="$rows[9]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase50}:</td><td><INPUT TYPE="text" NAME="last" VALUE="$rows[10]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase47}:</td><td><INPUT TYPE="text" NAME="cdate" VALUE="|; printf ("%02d:%02d %02d.%02d.%d",($t = localtime($rows[6]))->hour, $t->min, $t->mday, $t->mon+1, $t->year+1900); print qq|" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase37}:</td><td><INPUT TYPE="text" NAME="llog" VALUE="|; printf ("%02d:%02d %02d.%02d.%d",($t = localtime($rows[3]))->hour, $t->min, $t->mday, $t->mon+1, $t->year+1900); print qq|" $InputParam></td></tr>|;
		if ($rows[3] != 0) 
		{
			print qq|	
		<tr bgcolor="$TableColor"><td>$Language{phrase41}:</td><td>$rows[4]</td></tr>|;
		}
		print qq|
		<tr bgcolor="$TableColor"><td>$Language{phrase46}:</td><td><INPUT TYPE="CHECKBOX" NAME="bcst" VALUE="1"|; if ($rows[5] == 1) {print " checked";} print qq| $InputParam> $Language{phrase174}</td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase48}:</td><td><INPUT TYPE="CHECKBOX" NAME="cpass" VALUE="1"|; if ($rows[7] == 1) {print " checked";} print qq| $InputParam> $Language{phrase174}</td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase51} #1:</td><td><INPUT TYPE="text" NAME="email1" VALUE="$rows[11]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase51} #2:</td><td><INPUT TYPE="text" NAME="email2" VALUE="$rows[12]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase51} #3:</td><td><INPUT TYPE="text" NAME="email3" VALUE="$rows[13]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase52}:</td><td><INPUT TYPE="CHECKBOX" NAME="e1publ" VALUE="1"|; if ($rows[14] == 1) {print " checked";} print qq| $InputParam> $Language{phrase174}</td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase53}:</td><td><INPUT TYPE="CHECKBOX" NAME="auth" VALUE="0"|; if ($rows[16] == 0) {print " checked";} print qq| $InputParam> $Language{phrase174}</td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase54}:</td><td><INPUT TYPE="RADIO" NAME="sex" VALUE="1"|; if ($rows[17]==1) {print " checked";} print qq|> <INPUT TYPE="RADIO" NAME="sex" VALUE="2"|; if ($rows[17]==2) {print " checked";} print qq|> <INPUT TYPE="RADIO" NAME="sex" VALUE="0"|; if ($rows[17]==0) {print " checked";} print qq| $InputParam>?</td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase55}:</td><td><INPUT TYPE="text" NAME="age" VALUE="$rows[18]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase56}:</td><td><INPUT TYPE="text" NAME="bthd" VALUE="|; printf("%02d.%02d.%04d",$rows[19],$rows[20],$rows[21]+1900); print qq|" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td colspan=2>$Language{phrase57}:<BR><TEXTAREA NAME="notes" ROWS=4 COLS=50 $InputParam>$rows[35]</TEXTAREA></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase27} <a href="isdwm.cgi?action=newlock&uin=$rows[0]">$Language{phrase38}:</td><td>|; if ($rows[2]==1) {print "$Language{phrase39}";} else {print "$Language{phrase40}"} print qq|</td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase58}:</td><td><a href="isdwm.cgi?action=deluser&uin=$in{uin}">$Language{phrase60}</a> / <a href="isdwm.cgi?action=newlock&uin=$in{uin}">$Language{phrase61}</a></td></tr>
		<tr bgcolor="$TableColor"><td colspan="2" align="right"><INPUT TYPE="SUBMIT" VALUE=" $Language{phrase59} " $InputParam></td></tr>
	</table>
	</form>|;
	&PrintFooter; exit;
}
if ($in{action} eq "list") 
{
	&PrintHeader ("$Language{phrase62}");
	&PrintMenu (30);
	if ($in{sort} eq "nick") { $sort="ORDER BY nick" }
		elsif ($in{sort} eq "fname") { $sort="ORDER BY frst" }
			elsif ($in{sort} eq "lname") { $sort="ORDER BY last" }
				elsif ($in{sort} eq "email") { $sort="ORDER BY email1" }
					else { $sort="ORDER BY uin" };

	if (!$in{page}) {$in{page}=0;} else {$in{page}--};

	$PageS = $in{page}+1;
	{
		$LIMIT = qq(LIMIT $MaxPageItems, ).$MaxPageItems*$in{page};
	}
	
	$sth=$dbh->prepare("SELECT COUNT(uin) from users_info_ext");	
	$sth->execute;
	$TotalByQuery = $sth->fetchrow;
	$sth=$dbh->prepare("SELECT uin,nick,frst,last,pass,email1 from users_info_ext $sort $LIMIT");
	$sth->execute;
	$online=$dbh->prepare("SELECT uin, stat from online_users");
	$online->execute;
	$online_hash = $online -> fetchall_hashref('uin');
	for ($i = 1; $i<($TotalByQuery/$MaxPageItems)+1; $i++) 
	{
		if ($PageS != $i) 
		{
			$page .= qq(<a href="isdwm.cgi?action=list&sort=$in{sort}&page=$i"><b>$i</b></a> );
		}
			else
		{
			$page .= "<b>$i </b>";
		}

	}
	print qq(	<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=100%>
	<tr bgcolor=$TableColorStrip><td colspan=7 align="center"><b>$Language{phrase62}</b></td></tr>
	<FORM ACTION="isdwm.cgi" METHOD="GET">
	<tr bgcolor=$TableColorStrip><td colspan=7>$Language{phrase63}, UIN: <INPUT TYPE="hidden" NAME="action" VALUE="edituin"><INPUT TYPE="text" NAME="uin" SIZE="8" $InputParam> <INPUT TYPE="SUBMIT" VALUE="$Language{phrase90}" $InputParam></td></tr></form>
	<tr bgcolor=$TableColorStrip align="center"><td><a href="isdwm.cgi?action=list&sort=uin&page=1"><b>UIN</b></a></td><td><a href="isdwm.cgi?action=list&sort=nick&page=1"><b>$Language{phrase25}</b></a></td><td><a href="isdwm.cgi?action=list&sort=fname&page=1"><b>$Language{phrase49}</b></a></td><td><a href="isdwm.cgi?action=list&sort=lname&page=1"><b>$Language{phrase50}</b></a></td><td><b>$Language{phrase1}*</b></td><td><a href="isdwm.cgi?action=list&sort=email&page=1"><b>E-mail</b></a></td><td><img src="$URLToImages/status.gif" border=0 width="16" height="16" alt="$Language{phrase92}"></td></tr>);
	while($hash_ref = $sth->fetchrow_hashref) 
	{
		&WriteUser ($hash_ref->{uin},$hash_ref->{nick},$hash_ref->{frst},$hash_ref->{last},$hash_ref->{pass},$hash_ref->{email1}, $online_hash->{$hash_ref->{uin}}->{stat});
	}
	print qq|<tr><td colspan=7>$Language{phrase19}: $page</td></tr>|;
	print qq|<tr><td colspan=7><small>* $Language{phrase64}</small></td></tr></table>|;
	&PrintFooter; exit;
}
if ($in{action} eq "adduser") 
{
	&PrintHeader ("$Language{phrase69}");
	&PrintMenu (20);
	if ($in{do} eq "submit") 
	{
		if ($in{'cpass'} eq "on") { $cpass=1 } else { $cpass=0 };
		if ($in{'auth'} eq "on") { $auth=0 } else { $auth=1 };
		$time=time;
		$sth=$dbh->prepare("INSERT INTO users_info_ext (uin, pass, nick, frst, last, email1, cdate, cpass, auth, sex) values ($in{uin}, '$in{password}', '$in{nick}', '$in{frst}', '$in{last}', '$in{email}', $time, $cpass, $auth, '$in{sex}')");
		$sth->execute;
		$result = $sth->rows;
		if ($result==-2) { print "<b>$Language{phrase66}</b>"; }
		elsif ($result==1) { printf (qq(<b>$Language{phrase85}</b> <br><a href="isdwm.cgi?action=edituin&uin=$in{uin}">$Language{phrase81}), $in{uin}); }
		else { print "<b>$Language{phrase175}</b>"; }
		if ($in{sendmail} eq "on") 
		{
			unless (($in{email} =~ /.*\@.*\..*/) || ($in{email} =~ tr/;<>*|`&$!#()[]{}:'"//))
			{
				print "<br>$Language{phrase72}";
			}
			else
			{
				unless (open (MAIL, "|$sendmailprog -t")) 
				{
					print qq(<br>$Language{phrase77} <b>$sendmailprog</b>. $Language{phrase78} <a href="isdwm.cgi?action=setup">$Language{phrase79}</a>!);
					&PrintFooter;
					exit
				};
				print MAIL "To: $in{email}\n";
				print MAIL "From: $AdminMail\n";
				print MAIL "Subject: $MailRegSubject\n\n";
				$MailTextSubject =~ s/%uin%/$in{uin}/gi;
				$MailTextSubject =~ s/%pass%/$in{password}/gi;
				$MailTextSubject =~ s/%adminmail%/$AdminMail/gi;
				print MAIL "$MailTextSubject";
				close (MAIL);
			}
		}
		&PrintFooter;
		if ($in{regreq} eq "true") 
		{
			$rv=$dbh->do("DELETE FROM register_requests WHERE uin=$in{ruin}");
		}
		exit;
	}
	$MaxUIN = &GetFreeUIN;
	if ($in{'nick'}) {$default_nick = $in{'nick'};}
	if ($in{'frst'}) {$default_frst = $in{'frst'};}	
	if ($in{'last'}) {$default_last = $in{'last'};}	
	&PrintRegForm ($MaxUIN, $default_pass, $default_nick, $default_frst, $default_last, $in{email1}, $in{sex}, $in{regreq});
	&PrintFooter;
	exit;
};
if ($in{action} eq "regreq") 
{
	&PrintHeader ("$Language{phrase70}");
	&PrintMenu (70);
	if ($in{do} eq "delreq")
	{
		$rv=$dbh->do("DELETE FROM register_requests WHERE uin=$in{uin}");
		if ($rv != 1)
		{
			print ("<b>$Language{phrase71} #$in{uin}</b>");
		}
		else
		{
			print qq(<b>$Language{phrase80}</b><br><br><a href="isdwm.cgi?action=regreq">$Language{phrase82}</a>);
		}
		&PrintFooter;
		exit;
	}
	$sth=$dbh->prepare("SELECT uin,nick,frst,last,cdate,email1,notes,sex from register_requests");
	$sth->execute;
	$req=$sth->rows;

	print $sth->errstr if ($sth->errstr);

	print qq(<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=100%>
	<tr bgcolor=$TableColorStrip><td colspan=7 align=center><b>$Language{phrase88} ($req)</b></td></tr>
	<tr bgcolor=$TableColorStrip><td width="1"><nobr>$Language{phrase89}</nobr></td><td width="1">$Language{phrase25}</td><td width="1">$Language{phrase49}</td><td width="1">$Language{phrase50}</td><td width="1"><nobr>e-mail</nobr></td><td>$Language{phrase191}:</td><td width="1">$Language{phrase209}</td></tr>);
	while(@row=$sth -> fetchrow) 
	{
		&koi2win(@row);
		$date = sprintf ("%02d:%02d %02d.%02d.%d",($t = localtime($row[4]))->hour, $t->min, $t->mday, $t->mon+1, $t->year+1900);
		print qq(<tr bgcolor=$TableColor><td width="1">$date</td><td width="1">$row[1]</td><td width="1">$row[2]</td><td width="1">$row[3]</td><td width="1">$row[5]</td><td>$row[6]</td><td width="1"><a href="isdwm.cgi?action=adduser&nick=$row[1]&frst=$row[2]&last=$row[3]&email1=$row[5]&sex=$row[7]&ruin=$row[0]&regreq=true">$Language{phrase192}</a> <a href="isdwm.cgi?action=regreq&do=delreq&ruin=$row[0]">$Language{phrase60}</a></td></tr>);
	}
	print "</table>"; &PrintFooter; exit;
}

if ($in{action} eq "exit") 
{
	&ClearCookies ("adminuin", "adminpass");
	print "\n";
	&PrintEntryExit("$Language{phrase75}");
	print qq(<table><tr><td align=center><b>$Language{phrase73}</b><br>$Language{phrase74}<br><br>$Language{phrase83}.$Copyright</td></tr></table>);
	print <<HTML__;
</body>
</html>
HTML__
	exit;
}
if ($in{action} eq "lockchangetext") 
{
	&PrintHeader ("$Language{phrase84}");
	&PrintMenu(50);
	$rv=$dbh->do("UPDATE users_lock SET lck_text='$in{lck_text}' WHERE luin=$in{uin}");
	if ($rv != 1) 
	{
		printf ("<b>$Language{phrase91}<b>",$in{uin});
	}
	else
	{
		print "<b>UIN #$in{uin}: $Language{phrase93}</b><br><br>";
		print qq(<a href="isdwm.cgi?action=lockuser">$Language{phrase96}</a><br>
		<a href="isdwm.cgi?action=lockuser&do=lockedit&uin=$in{uin}">UIN #$in{uin}: $Language{phrase176}</a>);
	}
	&PrintFooter; exit;
}

if ($in{action} eq "newlock") 
{
	&PrintHeader ("$Language{phrase98}");
	&PrintMenu(60);
	if ($in{do} eq "lock")
	{
		$rv=$dbh->do("UPDATE users_info_ext SET ulock=1 WHERE uin=$in{uin}");
		if ($rv != 1) 
		{
			printf ("$Language{phrase86}", $in{uin});
			&PrintFooter;
			exit;
		}
		if ($in{lck_text} ne "")
		{
			$rv=$dbh->do("UPDATE users_lock SET lck_text='$in{lck_text}' where luin=$in{uin}");
			if ($rv !=1) 
			{
				$rv=$dbh->do("INSERT INTO users_lock VALUES ($in{uin},'$in{lck_text}')");
			}			
		}
		printf (qq(<b>$Language{phrase87}</b><br><br><a href="isdwm.cgi?action=lockuser">$Language{phrase193}</a>), $in{uin});
		&PrintFooter; exit;
	}
	&koi2win($default_lock_text);
	print qq(
	<FORM ACTION="isdwm.cgi" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="newlock">
	<INPUT TYPE="HIDDEN" NAME="do" VALUE="lock">
	<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=200 align=center>
	<tr bgcolor=$TableColorStrip><td colspan=2 align=center><b>$Language{phrase194}</b></td></tr>
	<tr bgcolor=$TableColor><td>UIN:</td>
	<td><INPUT TYPE="TEXT" NAME="uin" VALUE="$in{uin}" size=7 $InputParam></td></tr>
	<tr bgcolor=$TableColor><td>$Language{phrase97}:</td><td><TEXTAREA NAME="lck_text" ROWS=5 COLS=50 $InputParam>$default_lock_text</TEXTAREA></td></tr>
	<tr bgcolor=$TableColor><td>&nbsp;</td><td><INPUT TYPE="SUBMIT" VALUE="$Language{phrase195}" $InputParam></td></tr></form></table>);
	&PrintFooter; exit;
}

if ($in{action} eq "lockremove")
{
	&PrintHeader ("$Language{phrase196}");
	&PrintMenu(50);
	$rv=$dbh->do("UPDATE users_info_ext SET ulock=0 where uin=$in{uin}");
	$rv=$dbh->do("DELETE FROM users_lock where luin=$in{uin}");
	if ($rv != 1)
	{
		print "UIN #$in{uin}: $Language{phrase95}<BR><br>";
	}
	print "<b>UIN #$in{uin}: $Language{phrase197}</b><br><br>";
	print qq(<a href="isdwm.cgi?action=lockuser">$Language{phrase198}</a></b>);
	&PrintFooter; exit;
}

if ($in{action} eq "lockuser")
{
	if ($in{do} eq "lockedit")
	{
		$addon = "uin=$in{uin}";
	}
	else
	{
		$addon = "ulock=1";
	}
	$sth=$dbh->prepare("SELECT uin,nick,frst,last,email1 FROM users_info_ext WHERE $addon");
	$sth->execute;
	$count=$sth->rows;
	$sth2=$dbh->prepare("SELECT * FROM users_lock");
	$sth2->execute;
	$ban_hash = $sth2 -> fetchall_hashref('luin');
	if ($in{do} eq "lockedit")
	{
		&PrintHeader ("$Language{phrase177}");
		&PrintMenu(50);
		@row=$sth -> fetchrow;
		&koi2win(@row);
		$ban_comments = &koi2win($ban_hash->{$row[0]}->{lck_text});
		print qq|
		<FORM ACTION="isdwm.cgi" METHOD="POST">
		<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=100% align=center>
		<tr bgcolor=$TableColorStrip><td colspan=5 align=center><b>$Language{phrase199}</b></td></tr>
		<tr bgcolor=$TableColor><td><b>UIN</b></td><td><b>$Language{phrase25}</b></td><td><b>$Language{phrase49}</b></td><td><b>$Language{phrase50}</b></td><td><b>E-mail</b></td></tr>		<tr bgcolor=$TableColor><td><a href="isdwm.cgi?action=edituin&uin=$row[0]">$row[0]</a></td><td>$row[1]</td><td>$row[2]</td><td>$row[3]</td><td>$row[4]</td></tr>
		<tr bgcolor=$TableColor><td colspan=5 align=left>
		<BR>$Language{phrase210}:<BR>
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="lockchangetext">
		<INPUT TYPE="HIDDEN" NAME="uin" VALUE="$row[0]">
		<TEXTAREA NAME="lck_text" ROWS=5 COLS=50 $InputParam>$ban_comments</TEXTAREA><BR><INPUT TYPE="SUBMIT" VALUE="$Language{phrase219}" $InputParam> [ <a href="isdwm.cgi?action=lockremove&uin=$row[0]">$Language{phrase217}</a> \| <a href="isdwm.cgi?action=deluser&uin=$row[0]">$Language{phrase67}</a> ]
		</td></tr></table></FORM>|;
		&PrintFooter; exit;
	}
	&PrintHeader ("$Language{phrase189}");
	&PrintMenu(50);
	print qq|
	<FORM ACTION="isdwm.cgi" METHOD="POST"><INPUT TYPE="HIDDEN" NAME="action" VALUE="dobanuser">
	<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=100% align=center>
	<tr bgcolor=$TableColorStrip><td colspan=7 align=center><b>$Language{phrase190} ($count)</b></td></tr>|;
	if ($count != 0) {
		print qq|<tr bgcolor=$TableColor align=center><td width="1">UIN</td><td width="1">$Language{phrase25}</td><td width="1">$Language{phrase49}</td><td width="1">$Language{phrase50}</td><td width="1"><nobr>E-mail</nobr></td><td>$Language{phrase200}</td><td width="1"><nobr>$Language{phrase201}</nobr></td></tr>|;
		while(@row=$sth -> fetchrow) 
		{
			&koi2win(@row);
			$ban_comments = &koi2win($ban_hash->{$row[0]}->{lck_text});
			print qq(<tr bgcolor=$TableColor><td>$row[0]</td><td>$row[1]</td><td>$row[2]</td><td>$row[3]</td><td>$row[4]</td><td>$ban_comments</td><td width="1"><a href="isdwm.cgi?action=lockuser&do=lockedit&uin=$row[0]">$Language{phrase178}</a></td></tr>);
		}
	} else {
		print qq(<tr bgcolor=$TableColor><td colspan=7 align=center><b>$Language{phrase23}</b></td></tr>);
	}
	print "</table>";
	&PrintFooter;
	exit;
}
if ($in{action} eq "setup") 
{
	&Setup;
}
if ($in{action} eq "deluser") 
{
	if (($in{do} eq "delete") || ($in{del} eq "delete"))
	{
		&PrintHeader ("$Language{phrase179} #$in{uin}");
		&PrintMenu(40);
		if ($in{uin} =~ /\D/) 
		{
			print "$Language{phrase180}";
			&PrintFooter;
			exit;
		}
		$rv=$dbh->do("DELETE FROM users_info_ext WHERE uin=$in{uin}");
		if ($rv != 1)
		{
			print "UIN #$in{uin}: $Language{phrase181}";
		} 
			else
		{
			$rv=$dbh->do("DELETE FROM users_messages WHERE to_uin=$in{uin} OR from_uin=$in{uin}");
			$rv=$dbh->do("DELETE FROM users_lock WHERE luin=$in{uin}");
			print qq(<b>#$in{uin}: $Language{phrase182}</b><br><br><a href="isdwm.cgi?action=list">$Language{phrase202}</a>);
		}
		&PrintFooter;
		exit;
	}

	if ($in{do} eq "confirm")
	{
		&PrintHeader ("#$in{uin}: $Language{phrase183}");
		&PrintMenu(40);
		$sth=$dbh->prepare("SELECT nick,frst,last,email1,llog FROM users_info_ext WHERE uin=$in{uin}");
		$sth->execute;
		@row=$sth -> fetchrow;
		if (@row ==0) {print "{phrase203}"; print @Footer; exit;}
		&koi2win(@row);
		print qq(
		<FORM ACTION="isdwm.cgi" METHOD="GET">
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="deluser">
		<INPUT TYPE="HIDDEN" NAME="do" VALUE="delete">
		<INPUT TYPE="HIDDEN" NAME="uin" VALUE="$in{uin}">
		<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=450 align=center>
		<tr bgcolor=$TableColorStrip><td colspan=7 align=center><b>#$in{uin}: $Language{phrase183}</b></td></tr>
		<tr bgcolor=$TableColor align=center><td>$Language{phrase25}</td><td>$Language{phrase49}</td><td>$Language{phrase50}</td><td>E-mail</td><td>$Language{phrase211}</td></tr>
	        <tr bgcolor=$TableColor><td>$row[0]</td><td>$row[1]</td><td>$row[2]</td><td>$row[3]</td><td align="right">); printf ("%02d:%02d %02d.%02d.%d",($t = localtime($rows[6]))->hour, $t->min, $t->mday, $t->mon+1, $t->year+1900); print qq(</td></tr>
		<tr bgcolor=$TableColor><td colspan=5 align=center><INPUT TYPE="SUBMIT" TYPE="NAME" VALUE="$Language{phrase60}" $InputParam></td></tr></form></td></tr></table>);
		&PrintFooter;
		exit;
	}
	&PrintHeader ("$Language{phrase184}");
	&PrintMenu(40);
	print qq(
	<FORM ACTION="isdwm.cgi" METHOD="GET">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="deluser">
	<INPUT TYPE="HIDDEN" NAME="do" VALUE="confirm">
	<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=350 align=center>
	<tr bgcolor=$TableColorStrip><td colspan=7 align=center><b>$Language{phrase184}</b></td></tr>
	<tr bgcolor=$TableColor><td>$Language{phrase185}:</td><td><INPUT TYPE="TEXT" SIZE=8 VALUE="$in{uin}" NAME="uin" $InputParam>
	<INPUT TYPE="SUBMIT" TYPE="NAME" VALUE="$Language{phrase218}" $InputParam><br><INPUT TYPE="CHECKBOX" NAME="del" value="delete" $InputParam> $Language{phrase68}</td></tr>
	</table>
	</FORM>);
	&PrintFooter;
	exit;
}
#########################################################################
#			MAIN PAGE
#########################################################################

	&PrintHeader ("$Language{phrase204}");
	&PrintMenu;
       	$pid = `$ISD_control status`;
       	$sth=$dbh->prepare("SELECT COUNT (uin) from users_info_ext");
       	$sth->execute;
       	$TotalCount = $sth->fetchrow_array;
       	$sth=$dbh->prepare("SELECT COUNT (uin) from online_users");
       	$sth->execute;
       	$OnlineCount = $sth->fetchrow_array;
       	$sth=$dbh->prepare("SELECT COUNT (uin) FROM register_requests");
       	$sth->execute;
       	$RRequestCount = $sth->fetchrow_array;
       	$sth=$dbh->prepare("SELECT COUNT (to_uin) FROM users_messages");
       	$sth->execute;
       	$MessagesCount= $sth->fetchrow_array;
       	$sth=$dbh->prepare("SELECT COUNT (ulock) FROM users_info_ext where ulock=1");
       	$sth->execute;
       	$UlockCount= $sth->fetchrow_array;
       	if ($pid =~ /stopped/) {$pid = "$Language{phrase205}"}
       		elsif ($pid =~ /running/) {$pid = "$Language{phrase206}"}
       			else {$pid = "$Language{phrase212}"}
       	print <<HTML__;
       <table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=420 valign="center">
       	<tr bgcolor=$TableColorStrip><td colspan=2 align=center><b>$Language{phrase169}:</b></td></tr>
       	<tr bgcolor=$TableColor><td>$Language{phrase102}:</td><td><b>$pid</b></td></tr>
       	<tr bgcolor=$TableColor><td>$Language{phrase103}:</td><td><b>$TotalCount</b></td></tr>
       	<tr bgcolor=$TableColor><td>$Language{phrase104}:</td><td><b>$OnlineCount</b></td></tr>
       	<tr bgcolor=$TableColor><td>$Language{phrase105}:</td><td><b>$RRequestCount</b></td></tr>
       	<tr bgcolor=$TableColor><td>$Language{phrase106}:</td><td><b>$MessagesCount</b></td></tr>
       	<tr bgcolor=$TableColor><td>$Language{phrase107}:</td><td><b>$UlockCount</b></td></tr>
       </table>
HTML__

	&PrintFooter;
	exit;

sub PrintHeader
{
	print "\n";
	$Title = shift || "ISD Web Manager";
	print <<HTML__;
<html>
<head>
<style type="text/css">
BODY, TD {
$BodyTDStyle
}
 A:link {
$ALink
}
 A:visited { 
$ALink
}
 A:hover {
$AHover
}
INPUT {
	background-color : $InputBGColor;
	color: Black;
	border: solid Black 1;
	font : 14px Arial;
	height : 20px;
}
TEXTAREA {
	background-color : $InputBGColor;
	border: solid Black 1;
}

TABLE {
	background-color : $MainTableColor;
	font : smaller Verdana;
}

</style>

<title>$Title</title>
<meta http-equiv="Content-Type" content="text/html; $WebCodepage">
</head>

<body bgcolor="$BGColor" text="$TextColor">
<table width="$MainTableSize" border="0" cellspacing="1" cellpadding="$MainTableCellPadding">
  <tr valign=top>
    <td width="$LeftTableSize" align="left"><img src="$URLToImages/isdwmlogo.gif" width="180" height="60"><br>
HTML__
}

sub PrintFooter
{
	print qq(
</td></tr><tr valign=top><td>&nbsp;</td><td align=center>$Copyright<br><br></td></tr>
</table>
</body>
</html>);
}
sub PrintMenu
{
	$Item = shift || 10;
	print <<HTML__;
      <table width="100%" border="0" cellspacing="0" cellpadding="$MenuCellPadding">
HTML__
	foreach (sort { $a<=>$b} keys %MenuItems)
	{
		if ($Item == $_) {
			print <<HTML__;
        <tr> 
          <td bgcolor="$MenuSelectedColor" onmouseover="this.style.backgroundColor='$MenuOverColor';"
	      onmouseout="this.style.backgroundColor='$MenuSelectedColor';">&raquo;&nbsp;<small><a href="isdwm.cgi?action=$MenuItems{$_}->[1]">$MenuItems{$_}->[0]</a></small></td>
        </tr>
HTML__
		} else {
			print <<HTML__;
        <tr> 
          <td onmouseover="this.style.backgroundColor='$MenuOverColor';"
	      onmouseout="this.style.backgroundColor='$MainTableColor';">&raquo;&nbsp;<small><a href="isdwm.cgi?action=$MenuItems{$_}->[1]">$MenuItems{$_}->[0]</a></small></td>
        </tr>
HTML__
		}
	}
	print qq(      </table>
    </td>
    <td align="center">);
}

sub PrintRegForm
{
	&koi2win(@_);
	my ($uin, $pass, $nick, $frst, $last, $email, $sex, $regreq) = @_;
	my ($a, $b, $c);
	if ($sex == 1)
	{
		$a="selected";
	}
	elsif ($sex == 2)
	{
		$b="selected";
	}
	else
	{
		$c="selected";
	}
	print qq|	<FORM ACTION="isdwm.cgi" METHOD="GET">
	<INPUT TYPE="hidden" NAME="do" VALUE="submit">
	<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=100%>
		<tr bgcolor=$TableColorStrip><td colspan=2 align=center><b>$Language{phrase172}</b></td>
		<tr bgcolor=$TableColor><td>UIN:</td><td><INPUT TYPE="HIDDEN" NAME="action" VALUE="adduser"><INPUT TYPE="text" NAME="uin" SIZE="8" VALUE="$uin" $InputParam> </td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase1}:</td><td><INPUT TYPE="password" NAME="password" SIZE="8" MAXLENGTH="8" VALUE="$pass" $InputParam> </td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase25}:</td><td><INPUT TYPE="text" NAME="nick" VALUE="$nick" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase49}:</td><td><INPUT TYPE="text" NAME="frst" VALUE="$frst" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase50}:</td><td><INPUT TYPE="text" NAME="last" VALUE="$last" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>e-mail:</td><td><INPUT TYPE="text" NAME="email" VALUE="$email" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase213}:</td><td><SELECT NAME="sex" $InputParam><OPTION VALUE="2" $b>$Language{phrase214}<OPTION value="1" $a>$Language{phrase215}<OPTION value="0" $c>$Language{phrase212}</SELECT></td></tr>|;
	if ($mail_reg eq "yes") {print qq|		<tr bgcolor=$TableColor><td>$Language{phrase186}:</td><td><INPUT TYPE="checkbox" NAME="sendmail" $InputParam> $Language{phrase187}</td></tr>|;}
		print qq|		<tr bgcolor=$TableColor><td>$Language{phrase168}:</td><td><INPUT TYPE="checkbox" NAME="cpass" CHECKED $InputParam> $Language{phrase207}</td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase167}:</td><td><INPUT TYPE="checkbox" NAME="auth" $InputParam> $Language{phrase173}</td></tr>|;
	if (defined $regreq)
		{
			print qq|		<tr bgcolor=$TableColor><td>$Language{phrase65}:</td><td><INPUT TYPE="checkbox" NAME="regreq" VALUE="true" checked $InputParam> $Language{phrase60}</td></tr>
			<INPUT TYPE="hidden" NAME="ruin" VALUE="$in{ruin}">|;
		}
	print <<HTML__;
		<tr bgcolor=$TableColor><td>&nbsp;</td><td><INPUT TYPE="submit" NAME="submit" VALUE="$Language{phrase208}" $InputParam> <INPUT TYPE="RESET" NAME="Reset" VALUE="$Language{phrase166}" $InputParam></td></tr>
	</table>
	</FORM>

HTML__
}

sub PrintEntryExit
{
	print "\n";
	$title = shift;
print <<HTML__;
<html>
<head>
<style type="text/css">
INPUT {
	background-color : $InputBGColor;
	border: solid  Black 1;
	font : 14px Arial;
	height : 20px;
}
BODY, TD {
$BodyTDStyle
}
</style>
<title>$title</title>
<meta http-equiv="Content-Type" content="text/html; $WebCodepage">
</head>
<body bgcolor="$BGColor" text="$TextColor">
<div align="center">
        <img src="$URLToImages/isdwmlogo.gif" width="180" height="60">
HTML__
}
# KOI8-R => WIN1251
sub koi2win
{
	if ($koi2win ne "yes")
	{
		return
	};

	foreach (@_)
	{
		$_ =~ tr/\200-\377/\200\201\202\203\204\205\206\207\210\211\212\213\214\215\216\217\220\221\222\223\224\225\226\227\230\231\240\233\260\235\267\237\232\241\242\270\244\245\246\247\263\251\252\253\254\255\256\257\234\261\262\250\264\265\266\236\243\271\272\273\274\275\276\251\376\340\341\366\344\345\364\343\365\350\351\352\353\354\355\356\357\377\360\361\362\363\346\342\374\373\347\370\375\371\367\372\336\300\301\326\304\305\324\303\325\310\311\312\313\314\315\316\317\337\320\321\322\323\306\302\334\333\307\330\335\331\327\332/;
	}
	return (wantarray ? @_ : "@_")
};

# WIN1251 => KOI8-R
sub win2koi
{
	if ($win2koi ne "yes")
	{
		return
	};

	foreach (@_)
	{
		$_ =~ tr/\200-\377/\200\201\202\203\204\205\206\207\210\211\212\213\214\215\216\217\220\221\222\223\224\225\226\227\230\231\240\233\260\235\267\237\232\241\242\270\244\245\246\247\263\251\252\253\254\255\256\257\234\261\262\250\264\265\266\236\243\271\272\273\274\275\276\251\341\342\367\347\344\345\366\372\351\352\353\354\355\356\357\360\362\363\364\365\346\350\343\376\373\375\377\371\370\374\340\361\301\302\327\307\304\305\326\332\311\312\313\314\315\316\317\320\322\323\324\325\306\310\303\336\333\335\337\331\330\334\300\321/;
	}
	return (wantarray ? @_ : "@_")

}

#   2  -  (UIN)  ,
#      .

# SECURITY
sub CheckAccess
{
	my ($uin, $pass) = @_;
	$sth=$dbh->prepare("SELECT uin FROM users_info WHERE uin IN ($Admins) AND uin='$uin' AND pass='$pass'");
	$sth->execute;
	if ($sth->rows==1)
	{
		return 1;
	}
};
#    http-.
sub SetCookies
{
	if ($in{remember} eq "on") {$exp = q| expires="|.gmtime(time+10000000).q|";|;}
	print "Set-Cookie: $_[0]=$_[1];$exp\n";
}
# Clearing cookies
sub ClearCookies
{
	foreach (@_)
	{
		print qq(Set-Cookie: $_=;\n);
	}
}

sub GetFreeUIN
{
	if ($FirstFreeUIN eq "yes")
	{
		$sth=$dbh->prepare("SELECT uin FROM users_info_ext WHERE (uin<=$MaxAddUIN AND uin>=$MinAddUIN) ORDER BY uin");
		$sth->execute;
		$prevUIN=0;
		$FreeUIN=0;
		while ($hash_ref = $sth->fetchrow_hashref and $FreeUIN == 0)
		{
			if ($prevUIN!=0) 
				{
					if ($hash_ref->{uin}-$prevUIN > 1 ) {$FreeUIN=++$prevUIN;}
				};
			$prevUIN=$hash_ref->{uin};
		}
	return $FreeUIN;
	}
        $sth=$dbh->prepare("SELECT MAX (uin) from users_info_ext WHERE (uin<$MaxAddUIN and uin>$MinAddUIN)");
	$sth->execute;
	my $MaxUIN = $sth->fetchrow_array;
	return ++$MaxUIN;
}

sub WriteUser
{
        &koi2win(@_);
	my ($uin, $nick, $fname, $lname,$pass, $email, $status) = @_;
	print qq(<tr bgcolor = $TableColor><td align=center><a href="isdwm.cgi?action=edituin&uin=$uin">$uin</a></td><td>$nick</td><td>$fname</td><td>$lname</td><td width=1><font color="$TableColor"><nobr>$pass</nobr></font></td><td width="1">$email</td><td align=center>);
	if (defined $status)
	{
		defined $OnlineStatus{$status} ? &PrintOnlineStatus ($status) : &PrintOnlineStatus (257);
	}
	else
	{
		&PrintOnlineStatus (258);
	}
	print "</td></tr>\n";
}

sub PrintOnlineStatus
{
	my $status = shift;
	print qq(<img src="$URLToImages/$OnlineStatus{$status}->[0]" border=0 width="16" height="16" alt="$OnlineStatus{$status}->[1]">);
}

sub GetIP
{
	use Socket;
	$_[0] = inet_ntoa(pack("L", $_[0]));
}
sub Setup
{
	$CallStatus = shift;
	&PrintHeader ("$Language{phrase94}");
	if ($CallStatus == 1)
	{
		$AddOn = "<tr bgcolor=$TableColor><td colspan=2><b>$Language{phrase99}</b></td>"
	}
        elsif ($CallStatus == 2)
	{
		$AddOn = "<tr bgcolor=$TableColor><td colspan=2><b>$Language{phrase100}</b></td>"
	}
   	elsif ($CallStatus == 3){
		$AddOn = "<tr bgcolor=$TableColor><td colspan=2><b>$Language{phrase101}</b></td>"
	}
   	elsif ($CallStatus == 3){
		$AddOn = "<tr bgcolor=$TableColor><td colspan=2><b>$Language{phrase101}</b></td>"
	}
   	elsif ($CallStatus == 4){
		print qq|<b>$Language{phrase125}:<br>$DBI::errstr</b>|; exit;
	}

	&PrintMenu(100);
	if (!$CallStatus)
	{
		&koi2win($default_lock_text, $default_pass, $default_nick, $default_frst, $default_last, $MailTextSubject, $MailRegSubject);
	}

	print qq|
	<FORM ACTION="isdwm.cgi" METHOD="POST">
	<INPUT TYPE="hidden" NAME="action" VALUE="savesettings">
	<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=100%>
		<tr bgcolor=$TableColorStrip><td colspan=2><B>$Language{phrase108}</B></td>
		$AddOn
		<tr bgcolor=$TableColor><td>$Language{phrase114}</td><td>$DBI::VERSION/$DBD::Pg::VERSION</td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase109}</td><td><INPUT TYPE="TEXT" NAME="db_name" VALUE="$db_name" $InputParam> </td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase110}</td><td><INPUT TYPE="TEXT" NAME="db_user" VALUE="$db_user" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase111}</td><td><INPUT TYPE="TEXT" NAME="db_pass" VALUE="$db_pass" $InputParam> </td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase126}</td><td><INPUT TYPE="TEXT" NAME="Admins" VALUE="$Admins" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase112}</td><td><INPUT TYPE="TEXT" NAME="ISD_control" VALUE="$ISD_control" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase113}</td><td><INPUT TYPE="CHECKBOX" NAME="mail_reg" VALUE="yes"|; if ($mail_reg eq "yes") {print " checked";} print qq|></td></tr>|;
		
		if ($enable_tr_features)
		{
			print qq|<tr bgcolor=$TableColor><td>$Language{phrase115}</td><td><INPUT TYPE="CHECKBOX" NAME="koi2win" VALUE="yes"|; if ($koi2win eq "yes") {print " checked";} print qq|></td></tr>
			<tr bgcolor=$TableColor><td>$Language{phrase116}</td><td><INPUT TYPE="CHECKBOX" NAME="win2koi" VALUE="yes"|; if ($win2koi eq "yes") {print " checked";} print qq|></td></tr>|;
		}

		print qq|
		<tr bgcolor=$TableColor><td>$Language{phrase117}</td><td><INPUT TYPE="TEXT" NAME="default_pass" VALUE="$default_pass" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase118}</td><td><INPUT TYPE="TEXT" NAME="default_nick" VALUE="$default_nick" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase119}</td><td><INPUT TYPE="TEXT" NAME="default_frst" VALUE="$default_frst" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase120}</td><td><INPUT TYPE="TEXT" NAME="default_last" VALUE="$default_last" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td colspan=2>$Language{phrase121}:<br><INPUT TYPE="TEXT" NAME="default_lock_text" SIZE="85" VALUE="$default_lock_text" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase122}</td><td><INPUT TYPE="TEXT" NAME="MinAddUIN" VALUE="$MinAddUIN" SIZE="5" $InputParam> - <INPUT TYPE="TEXT" NAME="MaxAddUIN" VALUE="$MaxAddUIN" SIZE="5" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase123}</td><td><INPUT TYPE="CHECKBOX" NAME="FirstFreeUIN" VALUE="yes"|; if ($FirstFreeUIN eq "yes") {print " checked";} print qq|></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase124}</td><td><INPUT TYPE="TEXT" NAME="URLToImages" VALUE="$URLToImages" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase127}</td><td><INPUT TYPE="TEXT" NAME="MaxPageItems" VALUE="$MaxPageItems" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase128}</td><td><INPUT TYPE="TEXT" NAME="sendmailprog" VALUE="$sendmailprog" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase129}</td><td><INPUT TYPE="TEXT" NAME="AdminMail" VALUE="$AdminMail" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td colspan=2>$Language{phrase130}:<br><INPUT TYPE="TEXT" NAME="MailRegSubject" SIZE="85" VALUE="$MailRegSubject" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td colspan=2>$Language{phrase131}:<BR><TEXTAREA NAME="MailTextSubject" ROWS=5 COLS=65 $InputParam>$MailTextSubject</TEXTAREA><br>$Language{phrase188}</td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase132}</td><td><INPUT TYPE="TEXT" NAME="MainTableSize" VALUE="$MainTableSize" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase133}</td><td><INPUT TYPE="TEXT" NAME="LeftTableSize" VALUE="$LeftTableSize" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase134}</td><td><INPUT TYPE="TEXT" NAME="InputBGColor" VALUE="$InputBGColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase135}</td><td><INPUT TYPE="TEXT" NAME="InputMouseOver" VALUE="$InputMouseOver" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase136}</td><td><INPUT TYPE="TEXT" NAME="TableBorderColor" VALUE="$TableBorderColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase137}</td><td><INPUT TYPE="TEXT" NAME="TableColor" VALUE="$TableColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase138}</td><td><INPUT TYPE="TEXT" NAME="RightTablesCellPadding" VALUE="$RightTablesCellPadding" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase139}</td><td><INPUT TYPE="TEXT" NAME="MainTableColor" VALUE="$MainTableColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase140}</td><td><INPUT TYPE="TEXT" NAME="MainTableCellPadding" VALUE="$MainTableCellPadding" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase141}</td><td><INPUT TYPE="TEXT" NAME="TableColorStrip" VALUE="$TableColorStrip" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase142}</td><td><INPUT TYPE="TEXT" NAME="TextColor" VALUE="$TextColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase143}</td><td><INPUT TYPE="TEXT" NAME="BGColor" VALUE="$BGColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase144}</td><td><INPUT TYPE="TEXT" NAME="MenuSelectedColor" VALUE="$MenuSelectedColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase145}</td><td><INPUT TYPE="TEXT" NAME="MenuOverColor" VALUE="$MenuOverColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase146}</td><td><INPUT TYPE="TEXT" NAME="WebCodepage" VALUE="$WebCodepage" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase147}</td><td><INPUT TYPE="TEXT" NAME="MenuCellPadding" VALUE="$MenuCellPadding" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td colspan=2>$Language{phrase148}<BR><TEXTAREA NAME="BodyTDStyle" ROWS=5 COLS=65 $InputParam>$BodyTDStyle</TEXTAREA></td></tr>
		<tr bgcolor=$TableColor><td colspan=2>$Language{phrase149}<BR><TEXTAREA NAME="ALink" ROWS=5 COLS=65 $InputParam>$ALink</TEXTAREA></td></tr>
		<tr bgcolor=$TableColor><td colspan=2>$Language{phrase150}<BR><TEXTAREA NAME="AHover" ROWS=5 COLS=65 $InputParam>$AHover</TEXTAREA></td></tr>
		<tr bgcolor=$TableColor><td colspan=2 align="center"><br><INPUT TYPE="SUBMIT" VALUE="$Language{phrase151}" $InputParam></td></tr>
		</TABLE>
		</FORM>|;
	&PrintFooter; exit;
};

sub ParseLanguage
{
	unless (eval  {do "language.conf"})
	{
		&PrintHeader;
		print "<h1>UNABLE TO READ LANGUAGE FILE!</h1>";
		&PrintFooter;
		exit;
	}
}
